use miette::IntoDiagnostic;
use smol::stream::StreamExt;

async fn handle(_stream: smol::io::Result<smol::net::TcpStream>) -> smol::io::Result<()> {
    todo!()
}

fn main() -> miette::Result<()> {
    smol::block_on(async {
        smol::net::TcpListener::bind("0.0.0.0:42042")
            .await
            .into_diagnostic()?
            .incoming()
            .for_each(|stream| {
                smol::spawn(async {
                    if let Err(e) = handle(stream).await.into_diagnostic() {
                        eprintln!("{e}");
                    }
                })
                .detach()
            })
            .await;
        Ok(())
    })
}
